import * as types from '../../types';

export default {
    [types.GET_CONTACTS]: state => (id) => {
        return state.distributors.find(distributor => distributor.id === id).contacts || [];
    },
    [types.GET_CONTACT_FIELDS]: state => (id) => {
        let dist = state.distributors.find(distributor => distributor.id === id);
        let keys = Object.keys(dist);
        keys.push('actions'); //Adding Action column
        return keys;
    },
    [types.GET_DISTRIBUTORS]: state => {
        return state.distributors;
    },
    [types.GET_DISTRIBUTOR]: state => (id) => {
        return state.distributors.find(distributor => distributor.id === id) || {};
    },
    [types.GET_FIELDS]: state => {
        let keys = Object.keys(state.distributors[0]);
        keys.push('actions'); //Adding Action column
        keys = keys.slice(1); //Removing the title
        return keys;
    },
    [types.GET_ITEMS]: state => {
        let items = [];
        items = state.distributors.map(dist => {
            return {
                id: dist.id,
                title: dist.title,
                notes: dist.notes,
                contacts: dist.contacts.map( (contact, index) => {
                    return index === 0 ? contact.name : `, ${contact.name}`;
                })
            }
        });

        return items;
    },
};